Summary:   An intrusion detection system
Name:      snort
Version:   2.1.0
Release:   alt2.2
Copyright: GPL
Group:     Security/Networking

Source0:   http://www.snort.org/dl/%name-%version.tar.gz
#Source1:   http://www.prelude-ids.org/download/releases/snort-prelude-reporting-patch-0.2.5.tar.gz
#Source2:   http://cerberus.sourcefire.com/~jeff/archives/snort/sp_respond2/sp_respond2.diff.gz
Patch1:    %name-%version-prelude-0.3.0.diff
Source10:  README
Source99:  snortd
Url:       http://www.snort.org

Requires:  libpcap >= 0.4
Requires:  libprelude

# Automatically added by buildreq on Thu May 13 2004
BuildRequires: libMySQL-devel libnet1-devel libpcap-devel libpcre-devel libpq3-devel libprelude-devel libssl-devel libunixODBC-devel-static postgresql-devel zlib-devel

BuildRequires: libpcap-devel >= 0.4 
BuildRequires: libnet1-devel = 1.0.2a 
BuildRequires: libssl
BuildRequires: libunixODBC-devel

%description
Snort is a libpcap-based packet sniffer/logger which can be used as a
lightweight network intrusion detection system.  It features rules
based logging and can perform protocol analysis, content
searching/matching and can be used to detect a variety of attacks and
probes, such as buffer overflows, stealth port scans, CGI attacks, SMB
probes, OS fingerprinting attempts, and much more.  Snort has a
real-time alerting capabilty, with alerts being sent to syslog, a
seperate "alert" file, or as a WinPopup message via Samba's smbclient.

Please see the documentation in %_docdir/%name-%version

%description -l ru_RU.KOI8-R
Snort --       ,
   libpcap.    
 ,     .

       
  ,       
 ( ,    SMB,
-,  CGI,    
 ).

Snort        
,    -,  
""   WinPopup-,   
smbclient.

,    , 
  %_docdir/%name-%version

%description -l uk_UA.KOI8-U
Snort --   Ӧ    
Ԧ,   ¦̦æ libpcap.  դ  
   ͦ  ̦ ͦ .

     Ԧ  
  ֦,     ҦΦΦ  
  ( ,  Ԧ, ͦ
,  CGI, SMB,    æϧ 
  ).

Snort  צ צ   ¦  
צ, צΦ   -,  
""   WinPopup-צ, צ  
 smbclient.

-, '   æ,  ͦ 
%_docdir/%name-%version

%package contrib
Summary: Scripts/files which are not part of snort
Group: Security/Networking
%description contrib
What you find here are scripts/files which are not part of snort, but
are essential/helpful to get some of its features working.

This files placed to %_docdir/%name-contrib-%version/

%description -l ru_RU.KOI8-R contrib
        ,   
  %name,      
   .

     %_docdir/%name-contrib-%version/

%description -l uk_UA.KOI8-U contrib
  Ԧ      , Ҧ  
  %name,    Ԥ   
ۦ Ԧ.

   ͦΦ  %_docdir/%name-contrib-%version/

%package plain+flexresp
Summary: Snort (plain) with Flexible Response
Group: Security/Networking
Requires: %name = %version
Requires: libnet1
%description plain+flexresp
Snort compiled with flexresp support.  Requires snort libnet rpm.

%description -l ru_RU.KOI8-R plain+flexresp
Snort,    flexresp.  
libnet.

%description -l uk_UA.KOI8-U plain+flexresp
Snort, Ц  Ц flexresp.  ¦̦
libnet.

%package mysql
Summary: Snort with MySQL support
Group: Security/Networking
Requires: %name = %version
%description mysql
Snort compiled with mysql support.

%description -l ru_RU.KOI8-R mysql
Snort,    MySQL.

%description -l uk_UA.KOI8-U mysql
Snort, Ц  Ц MySQL.

%package mysql+flexresp
Summary: Snort with MySQL support and Flexible Response
Group: Security/Networking
Requires: %name = %version
Requires: libnet1
%description mysql+flexresp
Snort compiled with mysql support and flexresp support.  Requires
snort libnet rpm.

%description -l ru_RU.KOI8-R mysql+flexresp
Snort,    MySQL  flexresp. 
 libnet.

%description -l uk_UA.KOI8-U mysql+flexresp
Snort, Ц  Ц MySQL  flexresp. 
¦̦ libnet.

%package postgresql
Summary: Snort with PostgreSQL support
Group: Security/Networking
Requires: %name = %version
%description postgresql
Snort compiled with postgresql support. 

%description -l ru_RU.KOI8-R postgresql
Snort,    PostgreSQL.

%description -l uk_UA.KOI8-U postgresql
Snort, Ц  Ц PostgreSQL.

%package postgresql+flexresp
Summary: Snort with PostgreSQL support and Flexible Response
Group: Security/Networking
Requires: %name = %version
Requires: libnet1
%description postgresql+flexresp
Snort compiled with postgresql support and flexresp support.  Requires
snort libnet rpm.

%description -l ru_RU.KOI8-R postgresql+flexresp
Snort,    PostgreSQL  flexresp. 
 libnet.

%description -l uk_UA.KOI8-U postgresql+flexresp
Snort, Ц  Ц PostgreSQL  flexresp. 
¦̦ libnet.

%package odbc
Summary: Snort with unixODBC support
Group: Security/Networking
Requires: %name = %version
Requires: libunixODBC
%description odbc
Snort compiled with unixODBC support. 

%description -l ru_RU.KOI8-R odbc
Snort,    unixODBC.

%description -l uk_UA.KOI8-U odbc
Snort, Ц  Ц unixODBC.

%package odbc+flexresp
Summary: Snort with unixODBC support and Flexible Response
Group: Security/Networking
Requires: %name = %version
Requires: libnet1
Requires: libunixODBC
%description odbc+flexresp
Snort compiled with unixODBC support and flexresp support.  Requires
snort libnet rpm.

%description -l ru_RU.KOI8-R odbc+flexresp
Snort,    unixODBC  flexresp. 
 libnet.

%description -l uk_UA.KOI8-U odbc+flexresp
Snort, Ц  Ц unixODBC  flexresp. 
¦̦ libnet.

%package bloat
Summary: Snort with MySQL, PostgreSQL supports and Flexible Response
Group: Security/Networking
Requires: %name = %version
Requires: libnet1
%description bloat
Snort compiled with mysql, postgresql supports and flexresp support.
Requires snort libnet rpm.

%description -l ru_RU.KOI8-R bloat
Snort,    MySQL, PostgreSQL 
flexresp.   libnet.

%description -l uk_UA.KOI8-U bloat
Snort, Ц  Ц MySQL, PostgreSQL 
flexresp.  ¦̦ libnet.

%prep
%setup -q -n %name-%version
%patch1 -p0
#%setup -q -D -a 1

%build
SNORT_BASE_CONFIG="--prefix=%_prefix \
	--sysconfdir=%_sysconfdir/%name \
	--with-openssl \
	--with-libpcap \
	--enable-linux-smp-stats \
	--with-prelude"

#%__mv README doc/README-PATCH.PRELUDE
%__cp %SOURCE10 doc/README-PATCH.PRELUDE

%__mkdir_p building
#%__patch -p0 < %name-2.0.2-prelude.diff
%_buildshell ./autogen.sh
touch -r . *
%__aclocal
%__autoheader
%__automake
%__autoconf

%__mkdir_p building

# plain
%__mkdir_p plain
pushd plain
%__ln_s ../configure ./configure
%configure \
	$SNORT_BASE_CONFIG \
	--with-mysql=no \
        --with-postgresql=no \
        --with-oracle=no \
        --with-odbc=no
%make
%__mv src/%name ../building/%name-plain
popd

# plain+flexresp
%__mkdir_p plain+flexresp
pushd plain+flexresp
%__ln_s ../configure ./configure
%configure \
	$SNORT_BASE_CONFIG \
	--with-mysql=no \
        --with-postgresql=no \
        --with-oracle=no \
        --with-odbc=no \
        --enable-flexresp
%make
%__mv src/%name ../building/%name-plain+flexresp
popd

# mysql+flexresp
%__mkdir_p mysql+flexresp
pushd mysql+flexresp
%__ln_s ../configure ./configure
%configure \
	$SNORT_BASE_CONFIG \
	--with-mysql=yes \
        --with-postgresql=no \
        --with-oracle=no \
        --with-odbc=no \
        --enable-flexresp
%make
%__mv src/%name ../building/%name-mysql+flexresp
popd

# mysql
%__mkdir_p mysql
pushd mysql
%__ln_s ../configure ./configure
%configure \
	$SNORT_BASE_CONFIG \
	--with-mysql=yes \
        --with-postgresql=no \
        --with-oracle=no \
        --with-odbc=no
%make
%__mv src/%name ../building/%name-mysql
popd

# postgresql+flexresp
%__mkdir_p postgresql+flexresp
pushd postgresql+flexresp
%__ln_s ../configure ./configure
%configure \
	$SNORT_BASE_CONFIG \
	--with-mysql=no \
        --with-postgresql=yes \
        --with-oracle=no \
        --with-odbc=no \
        --enable-flexresp
%make
%__mv src/%name ../building/%name-postgresql+flexresp
popd

# postgresql
%__mkdir_p postgresql
pushd postgresql
%__ln_s ../configure ./configure
%configure \
	$SNORT_BASE_CONFIG \
	--with-mysql=no \
        --with-postgresql=yes \
        --with-oracle=no \
        --with-odbc=no 
%make
%__mv src/%name ../building/%name-postgresql
popd

# unixODBC+flexresp
%__mkdir_p unixODBC+flexresp
pushd unixODBC+flexresp
%__ln_s ../configure ./configure
%configure \
	$SNORT_BASE_CONFIG \
	--with-mysql=no \
        --with-postgresql=no \
        --with-oracle=no \
        --with-odbc=yes \
        --enable-flexresp
%make
%__mv src/%name ../building/%name-odbc+flexresp
popd

# unixODBC
%__mkdir_p unixODBC
pushd unixODBC
%__ln_s ../configure ./configure
%configure \
	$SNORT_BASE_CONFIG \
	--with-mysql=no \
        --with-postgresql=no \
        --with-oracle=no \
        --with-odbc=yes 
%make
%__mv src/%name ../building/%name-odbc
popd

# bloat
%__mkdir_p bloat
pushd bloat
%__ln_s ../configure ./configure
%configure \
	$SNORT_BASE_CONFIG \
	--with-mysql=yes \
        --with-postgresql=yes \
        --with-oracle=no \
        --with-odbc=yes \
        --enable-flexresp
%make
%__mv src/%name ../building/%name-bloat
popd

%install
%__mkdir_p $RPM_BUILD_ROOT/%_sysconfdir/%name
%__mkdir_p $RPM_BUILD_ROOT/%_sysconfdir/logrotate.d
%__mkdir_p $RPM_BUILD_ROOT/%_logdir/%name
%__mkdir_p $RPM_BUILD_ROOT/%_sbindir
%__mkdir_p $RPM_BUILD_ROOT/%_initdir
%__mkdir_p $RPM_BUILD_ROOT/%_sysconfdir/sysconfig
%__mkdir_p $RPM_BUILD_ROOT/%_man8dir

pushd building
%__install -m 755 %name-plain $RPM_BUILD_ROOT/%_sbindir/%name-plain
%__install -m 755 %name-plain+flexresp $RPM_BUILD_ROOT/%_sbindir/%name-plain+flexresp
%__install -m 755 %name-mysql $RPM_BUILD_ROOT/%_sbindir/%name-mysql
%__install -m 755 %name-mysql+flexresp $RPM_BUILD_ROOT/%_sbindir/%name-mysql+flexresp
%__install -m 755 %name-postgresql $RPM_BUILD_ROOT/%_sbindir/%name-postgresql
%__install -m 755 %name-postgresql+flexresp $RPM_BUILD_ROOT/%_sbindir/%name-postgresql+flexresp
%__install -m 755 %name-odbc $RPM_BUILD_ROOT/%_sbindir/%name-odbc
%__install -m 755 %name-odbc+flexresp $RPM_BUILD_ROOT/%_sbindir/%name-odbc+flexresp
%__install -m 755 %name-bloat $RPM_BUILD_ROOT/%_sbindir/%name-bloat
popd
%__install -m 644 %name.8 $RPM_BUILD_ROOT%_man8dir/
%__install -m 644 etc/*.{config,map} etc/%name.conf rules/*.rules $RPM_BUILD_ROOT/%_sysconfdir/%name
%__install -m 755 %SOURCE99 $RPM_BUILD_ROOT/%_initdir/
%__subst 's/^var RULE_PATH \.\.\/rules/var RULE_PATH \/etc\/%name/i' $RPM_BUILD_ROOT/%_sysconfdir/%name/%name.conf
%__cat > $RPM_BUILD_ROOT/%_sysconfdir/sysconfig/%name <<EOF
# Additional command line parameters for SNORT:
#
# INTERFACES=any
#    for all interfaces or list (comma separated):
# INTERFACES=ppp0,eth0,eth1...
#
# Additional parameters for all interfaces:
# ADDPARAMS_any="-A fast -b -d -D"
#    or additional parameters for interfaces ppp0, eth0, eth1:
# ADDPARAMS_ppp0="-A fast -b -d -D -c /etc/%name/%name-ppp0.conf"
# ADDPARAMS_eth0="-A fast -b -d -D -c /etc/%name/%name-eth0.conf"
# ADDPARAMS_eth1="-A fast -b -d -D -c /etc/%name/%name-eth1.conf"
#    
INTERFACES=any
ADDPARAMS_any="-A fast -b -d -D -c %_sysconfdir/%name/%name.conf"
EOF

%__cat > $RPM_BUILD_ROOT/%_sysconfdir/logrotate.d/%name <<EOF
%_logdir/%name/* %_logdir/%name/*/* {
    daily
    rotate 7
    missingok
    compress
    postrotate
        /sbin/service snortd restart 2>/dev/null || true
    endscript
}
EOF

%__cat > README-ALT.ru <<EOF
Snort --       ,
   libpcap.    
 ,     .

       
  ,       
 ( ,    SMB,
-,  CGI,    
 ).

Snort        
,    -,  
""   WinPopup-,   
smbclient.

 %name   
%_sysconfdir/%name/%name.conf    snortd   .

 8   .

     %name.     
   ,      
.

%_sbindir/%name        
 :

plain              plain+flexresp
mysql              mysql+flexresp
postgresql         postgresql+flexresp
odbc               odbc+flexresp
bloat              (mysql+postgresql+flexresp)
EOF

%__cat > README-ALT.uk <<EOF
Snort --   Ӧ    
Ԧ,   ¦̦æ libpcap.  դ  
   ͦ  ̦ ͦ .

     Ԧ  
  ֦,     ҦΦΦ  
  ( ,  Ԧ, ͦ
,  CGI, SMB,    æϧ 
  ).

Snort  צ צ   ¦  
צ, צΦ   -,  
""   WinPopup-צ, צ  
 smbclient.

Ʀ %name, צ  %_sysconfdir/%name/%name.conf 
 צ snortd   .

 8 Ҧ  Ԧ.

Ӧ     %name.     
   ,  ڦ  Ȧ  
æ.

%_sbindir/%name  ̦     ̦  
Ʀæ:

plain              plain+flexresp
mysql              mysql+flexresp
postgresql         postgresql+flexresp
odbc               odbc+flexresp
bloat              (mysql+postgresql+flexresp)
EOF

%post
# make a symlink if there is no link
%__ln_s -f %_sbindir/%name-plain %_sbindir/%name
%_sbindir/groupadd -rf %name
%_bindir/id %name > /dev/null 2>&1
RETVAL=$?
if [ $RETVAL -eq 1 ]; then
    %_sbindir/useradd -c "Snort IDS" -g %name -r -M -d /dev/null -s /dev/null %name
fi
%__chown %name.%name %_logdir/%name
%post_service snortd

%preun
%preun_service snortd
%__rm -f %_sbindir/%name

%postun
echo
echo You can delete fakeuser \"%name\" using command:
echo -e "\t%_sbindir/userdel %name"
echo if needed
echo

%files
%doc doc/AUTHORS doc/BUGS doc/CREDITS doc/FAQ doc/INSTALL doc/NEWS doc/README* doc/snort_manual.* doc/TODO doc/USAGE README-ALT.ru README-ALT.uk contrib/create_* doc/signatures
%config(noreplace) %_sysconfdir/%name/*.conf
%config(noreplace) %_sysconfdir/sysconfig/%name
%config(noreplace) %_initdir/snortd
%config(noreplace) %_sysconfdir/logrotate.d/%name
%config %_sysconfdir/%name/*.config
%config %_sysconfdir/%name/*.map
%config %_sysconfdir/%name/*.rules
%dir %_logdir/%name
%dir %_sysconfdir/%name
%_sbindir/%name-plain
%_man8dir/%name.*

%files contrib
%doc contrib/*

%files plain+flexresp
%_sbindir/%name-plain+flexresp

%files mysql
%_sbindir/%name-mysql

%files mysql+flexresp
%_sbindir/%name-mysql+flexresp

%files postgresql
%_sbindir/%name-postgresql

%files postgresql+flexresp
%_sbindir/%name-postgresql+flexresp

%files odbc
%_sbindir/%name-odbc

%files odbc+flexresp
%_sbindir/%name-odbc+flexresp

%files bloat
%_sbindir/%name-bloat

%post plain+flexresp
%__ln_s -f %_sbindir/%name-plain+flexresp %_sbindir/%name

%post mysql
%__ln_s -f %_sbindir/%name-mysql %_sbindir/%name

%post mysql+flexresp
%__ln_s -f %_sbindir/%name-mysql+flexresp %_sbindir/%name

%post postgresql
%__ln_s -f %_sbindir/%name-postgresql %_sbindir/%name

%post postgresql+flexresp
%__ln_s -f %_sbindir/%name-postgresql+flexresp %_sbindir/%name

%post odbc
%__ln_s -f %_sbindir/%name-odbc %_sbindir/%name

%post odbc+flexresp
%__ln_s -f %_sbindir/%name-odbc+flexresp %_sbindir/%name

%post bloat
%__ln_s -f %_sbindir/%name-bloat %_sbindir/%name

%preun plain+flexresp
%__ln_s -f %_sbindir/%name-plain %_sbindir/%name

%preun mysql
%__ln_s -f %_sbindir/%name-plain %_sbindir/%name

%preun mysql+flexresp
%__ln_s -f %_sbindir/%name-plain %_sbindir/%name

%preun postgresql
%__ln_s -f %_sbindir/%name-plain %_sbindir/%name

%preun postgresql+flexresp
%__ln_s -f %_sbindir/%name-plain %_sbindir/%name

%preun odbc
%__ln_s -f %_sbindir/%name-plain %_sbindir/%name

%preun odbc+flexresp
%__ln_s -f %_sbindir/%name-plain %_sbindir/%name

%preun bloat
%__ln_s -f %_sbindir/%name-plain %_sbindir/%name

%changelog
* Fri May 14 2004 Serge A. Volkov <vserge@altlinux.ru> 2.1.0-alt2.2
- Add Buildreq: libunixODBC-devel
- Add Requires: libunixODBC for all snort-odbc* packages

* Thu May 13 2004 Serge A. Volkov <vserge@altlinux.ru> 2.1.0-alt2.1
- Rebuild with openssl-0.9.7d

* Fri Feb  6 2004 Serhii Hlodin <hlodin@altlinux.ru> 2.1.0-alt1
- New release
- Enable statistics reporting through proc by default
- Add unixODBC support to bloat package

* Tue Nov 25 2003 Serhii Hlodin <hlodin@altlinux.ru> 2.0.5-alt1
- New release

* Thu Nov  6 2003 Serhii Hlodin <hlodin@altlinux.ru> 2.0.4-alt1
- New release
- Add script for logrotate
- Create new package %name-contrib for all contrib files

* Thu Oct 09 2003 Serhii Hlodin <hlodin@altlinux.ru> 2.0.2-alt1
- New release

* Sat Sep 06 2003 Serhii Hlodin <hlodin@altlinux.ru> 2.0.1-alt3
- Add official Prelude IDS patch from Krzysztof Zaraska
  <kzaraska@student.uci.agh.edu.pl>
- Modify description (russian, ukrainian). Thanks to Michael Shigorin
  <mike@osdn.org.ua>
- Add README-ALT.ru README-ALT.uk files to documentation

* Sat Aug 30 2003 Serhii Hlodin <hlodin@altlinux.ru> 2.0.1-alt2
- Add Prelude IDS patch

* Wed Aug 27 2003 Serhii Hlodin <hlodin@altlinux.ru> 2.0.1-alt1
- fix host endianess problem in udp decoder
- vlan decoding fixes from Michael Pomraning
- add tcp state checking to httpflow
- ignoring bad checksums throughout snort if checksumming is turned on
- config disable_ttcp_alerts is now also config disable_tcpopt_ttcp_alerts
- better initialization handling of low memory conditions pointing to the low memory search engine
- byte_jump / byte_test 2 byte cases handled and unified
- correctly assign port numbers on tcpoption events
- pass rule logic changed to "win" in specific multiple event cases
- named interface support for win32 from the winpcap folks
- spp_bo now also will work with log-only output plugins
- added window detection plugin documentation to manual
- lots of new rules and tons of rule documentation 
- init-script rewrited according to new policy
- remove patch for Prelude IDS

* Wed May 28 2003 Serhii Hlodin <hlodin@altlinux.ru> 2.0.0-alt3
- Fixed spec-file
- Fixed snord startup file

* Tue May 23 2003 Serhii Hlodin <hlodin@altlinux.ru> 2.0.0-alt2
- Update source URL
- Update initscript
- Removed command for delete fakeuser "snort" in %postun section
- Fixed %post section
- Add patch for Prelude IDS

* Sun May 11 2003 Serhii Hlodin <hlodin@altlinux.ru> 2.0.0-alt1
- Initial build based on original SNORT spec-file
